'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ButtonImage = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ButtonImage = exports.ButtonImage = function (_Component) {
  _inherits(ButtonImage, _Component);

  function ButtonImage() {
    _classCallCheck(this, ButtonImage);

    return _possibleConstructorReturn(this, (ButtonImage.__proto__ || Object.getPrototypeOf(ButtonImage)).apply(this, arguments));
  }

  _createClass(ButtonImage, [{
    key: 'renderImage',
    value: function renderImage(props) {
      var className = props.className,
          alt = props.alt,
          others = _objectWithoutProperties(props, ['className', 'alt']);

      var imgClassName = (0, _classnames2.default)('k-ButtonImage__img', className);

      return _react2.default.createElement('img', _extends({ className: imgClassName, alt: alt || '' }, others));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          tag = _props.tag,
          className = _props.className,
          tiny = _props.tiny,
          big = _props.big,
          huge = _props.huge,
          withoutPointerEvents = _props.withoutPointerEvents,
          withBorder = _props.withBorder,
          img = _props.img,
          others = _objectWithoutProperties(_props, ['tag', 'className', 'tiny', 'big', 'huge', 'withoutPointerEvents', 'withBorder', 'img']);

      var buttonClassName = (0, _classnames2.default)('k-ButtonImage', {
        'k-ButtonImage--tiny': tiny,
        'k-ButtonImage--big': big,
        'k-ButtonImage--huge': huge,
        'k-ButtonImage--withoutPointerEvents': withoutPointerEvents,
        'k-ButtonImage--withBorder': withBorder
      }, className);

      // Adds keyboard accessibility to `<a>`
      var tabindex = tag == 'a' && !this.props.href ? 0 : null;

      var Tag = tag;

      return _react2.default.createElement(
        Tag,
        _extends({ className: buttonClassName, tabIndex: tabindex }, others),
        this.renderImage(img)
      );
    }
  }]);

  return ButtonImage;
}(_react.Component);

ButtonImage.defaultProps = {
  tag: 'button',
  className: null,
  tiny: false,
  big: false,
  huge: false,
  withoutPointerEvents: false,
  withBorder: false,
  img: {
    className: null
  }
};