'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SimpleCard = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _card = require('kitten/hoc/card');

var _grid = require('kitten/components/grid/grid');

var _marger = require('kitten/components/layout/marger');

var _title = require('kitten/components/typography/title');

var _text = require('kitten/components/typography/text');

var _parser = require('kitten/helpers/utils/parser');

var _horizontalStroke = require('kitten/components/layout/horizontal-stroke');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SimpleCardComponent = function (_Component) {
  _inherits(SimpleCardComponent, _Component);

  function SimpleCardComponent() {
    _classCallCheck(this, SimpleCardComponent);

    return _possibleConstructorReturn(this, (SimpleCardComponent.__proto__ || Object.getPrototypeOf(SimpleCardComponent)).apply(this, arguments));
  }

  _createClass(SimpleCardComponent, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          imageProps = _props.imageProps,
          titleProps = _props.titleProps,
          title = _props.title,
          subtitle = _props.subtitle,
          paragraph = _props.paragraph,
          horizontalStroke = _props.horizontalStroke,
          others = _objectWithoutProperties(_props, ['imageProps', 'titleProps', 'title', 'subtitle', 'paragraph', 'horizontalStroke']);

      var Tag = this.props.href ? 'a' : 'div';

      var titleClassName = (0, _classnames2.default)('k-Card__title', titleProps.className);

      return _react2.default.createElement(
        Tag,
        others,
        _react2.default.createElement(
          _marger.Marger,
          { bottom: '2', className: 'k-Card__imageContainer' },
          _react2.default.createElement('img', _extends({}, imageProps, {
            className: 'k-Card__image',
            style: _extends({}, imageProps.style, styles.image)
          }))
        ),
        title && _react2.default.createElement(
          _marger.Marger,
          { top: '2', bottom: '.5' },
          _react2.default.createElement(
            _title.Title,
            _extends({
              tag: 'p'
            }, titleProps, {
              className: titleClassName,
              margin: false,
              modifier: 'senary'
            }),
            (0, _parser.parseHtml)(title)
          )
        ),
        subtitle && _react2.default.createElement(
          _marger.Marger,
          { top: '.5', bottom: '.5' },
          _react2.default.createElement(
            _text.Text,
            { size: 'micro', weight: 'regular' },
            (0, _parser.parseHtml)(subtitle)
          )
        ),
        paragraph && _react2.default.createElement(
          _marger.Marger,
          { top: '1', bottom: '.5' },
          _react2.default.createElement(
            _text.Text,
            { lineHeight: 'normal', size: 'micro', weight: 'light' },
            (0, _parser.parseHtml)(paragraph)
          )
        ),
        horizontalStroke && _react2.default.createElement(
          _marger.Marger,
          { top: '1.5' },
          _react2.default.createElement(_horizontalStroke.HorizontalStroke, { size: 'tiny' })
        )
      );
    }
  }]);

  return SimpleCardComponent;
}(_react.Component);

var styles = {
  image: {
    width: '100%',
    display: 'block'
  }
};

SimpleCardComponent.defaultProps = {
  imageProps: {
    src: 'https://placehold.it/200x200/caf4fe/caf4fe',
    alt: ''
  },
  titleProps: {},
  title: null,
  subtitle: null,
  paragraph: null,
  horizontalStroke: true
};

var SimpleCard = exports.SimpleCard = (0, _card.card)(SimpleCardComponent, {
  withoutBoxShadowOnHover: true
});