'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.VerticalCardWithAction = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _marger = require('kitten/components/layout/marger');

var _title = require('kitten/components/typography/title');

var _paragraph = require('kitten/components/typography/paragraph');

var _button = require('kitten/components/buttons/button');

var _colorsConfig = require('kitten/constants/colors-config');

var _colorsConfig2 = _interopRequireDefault(_colorsConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var VerticalCardWithAction = exports.VerticalCardWithAction = function (_Component) {
  _inherits(VerticalCardWithAction, _Component);

  function VerticalCardWithAction() {
    _classCallCheck(this, VerticalCardWithAction);

    return _possibleConstructorReturn(this, (VerticalCardWithAction.__proto__ || Object.getPrototypeOf(VerticalCardWithAction)).apply(this, arguments));
  }

  _createClass(VerticalCardWithAction, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          imageProps = _props.imageProps,
          title = _props.title,
          titleTag = _props.titleTag,
          description = _props.description,
          descriptionTag = _props.descriptionTag,
          button = _props.button,
          buttonModifier = _props.buttonModifier,
          others = _objectWithoutProperties(_props, ['imageProps', 'title', 'titleTag', 'description', 'descriptionTag', 'button', 'buttonModifier']);

      return _react2.default.createElement(
        _radium.StyleRoot,
        others,
        _react2.default.createElement(
          _marger.Marger,
          { bottom: '3' },
          this.renderImage()
        ),
        _react2.default.createElement(
          _marger.Marger,
          { top: '3', bottom: '3' },
          this.renderDescription()
        ),
        _react2.default.createElement(
          _marger.Marger,
          { top: '3', style: styles.button },
          this.renderAction()
        )
      );
    }
  }, {
    key: 'renderImage',
    value: function renderImage() {
      var _props$imageProps = this.props.imageProps,
          style = _props$imageProps.style,
          imageProps = _objectWithoutProperties(_props$imageProps, ['style']);

      return _react2.default.createElement('img', _extends({}, imageProps, { style: _extends({}, style, styles.image) }));
    }
  }, {
    key: 'renderDescription',
    value: function renderDescription() {
      var _props2 = this.props,
          title = _props2.title,
          titleTag = _props2.titleTag,
          description = _props2.description,
          descriptionTag = _props2.descriptionTag;


      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _marger.Marger,
          { bottom: description ? 1.5 : 0 },
          _react2.default.createElement(
            _title.Title,
            {
              modifier: 'senary',
              tag: titleTag,
              margin: false,
              style: styles.text
            },
            title
          )
        ),
        description && _react2.default.createElement(
          _marger.Marger,
          { top: '1.5' },
          _react2.default.createElement(
            _paragraph.Paragraph,
            {
              modifier: 'quaternary',
              tag: descriptionTag,
              margin: false,
              style: styles.text
            },
            description
          )
        )
      );
    }
  }, {
    key: 'renderAction',
    value: function renderAction() {
      var _props3 = this.props,
          button = _props3.button,
          buttonModifier = _props3.buttonModifier;


      return _react2.default.createElement(
        _button.Button,
        { modifier: buttonModifier, type: 'button' },
        button
      );
    }
  }]);

  return VerticalCardWithAction;
}(_react.Component);

VerticalCardWithAction.propTypes = {
  imageProps: _propTypes2.default.shape({
    src: _propTypes2.default.string.isRequired,
    alt: _propTypes2.default.string.isRequired,
    style: _propTypes2.default.shape({})
  }).isRequired,
  title: _propTypes2.default.string.isRequired,
  titleTag: _propTypes2.default.string,
  description: _propTypes2.default.string,
  descriptionTag: _propTypes2.default.string,
  button: _propTypes2.default.string.isRequired,
  buttonModifier: _propTypes2.default.string
};
VerticalCardWithAction.defaultProps = {
  imageProps: {
    style: {}
  },
  titleTag: 'h1',
  description: '',
  descriptionTag: 'p',
  buttonModifier: 'helium'
};


var styles = {
  image: {
    width: '100%',
    display: 'block'
  },

  text: {
    textAlign: 'center',
    color: _colorsConfig2.default.font1
  },

  button: {
    textAlign: 'center'
  }
};