'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DevGrid = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Grid over all elements that is toggled when calling ctrl+g.
var DevGrid = exports.DevGrid = function (_React$Component) {
  _inherits(DevGrid, _React$Component);

  function DevGrid(props) {
    _classCallCheck(this, DevGrid);

    var _this = _possibleConstructorReturn(this, (DevGrid.__proto__ || Object.getPrototypeOf(DevGrid)).call(this, props));

    _this.state = {
      visible: !!props.visible
    };

    _this.handleKeyDown = _this.handleKeyDown.bind(_this);
    return _this;
  }

  _createClass(DevGrid, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      window.addEventListener('keydown', this.handleKeyDown);

      if (window.sessionStorage.getItem(this.props.storageKey)) this.setState({ visible: true });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('keydown', this.handleKeyDown);
    }
  }, {
    key: 'handleKeyDown',
    value: function handleKeyDown(e) {
      var char = String.fromCharCode(e.keyCode).toLowerCase();
      if (!e.ctrlKey || char != 'g') return;

      if (this.state.visible) this.hide();else this.show();
    }
  }, {
    key: 'show',
    value: function show() {
      window.sessionStorage.setItem(this.props.storageKey, 'on');
      this.setState({ visible: true });
    }
  }, {
    key: 'hide',
    value: function hide() {
      window.sessionStorage.removeItem(this.props.storageKey);
      this.setState({ visible: false });
    }
  }, {
    key: 'render',
    value: function render() {
      var style = this.state.visible ? null : { display: 'none' };
      return _react2.default.createElement(
        'div',
        { style: style },
        _react2.default.createElement('div', { className: 'k-DevBreakpoint' }),
        _react2.default.createElement(
          'div',
          { className: 'k-DevGrid' },
          _react2.default.createElement(
            'div',
            { className: 'k-DevGrid__container' },
            _react2.default.createElement(
              'div',
              { className: 'k-DevGrid__row' },
              _react2.default.createElement(
                'div',
                { className: 'k-DevGrid__col' },
                _react2.default.createElement('div', { className: 'k-DevGrid__inner' })
              ),
              _react2.default.createElement(
                'div',
                { className: 'k-DevGrid__col' },
                _react2.default.createElement('div', { className: 'k-DevGrid__inner' })
              ),
              _react2.default.createElement(
                'div',
                { className: 'k-DevGrid__col' },
                _react2.default.createElement('div', { className: 'k-DevGrid__inner' })
              ),
              _react2.default.createElement(
                'div',
                { className: 'k-DevGrid__col' },
                _react2.default.createElement('div', { className: 'k-DevGrid__inner' })
              ),
              _react2.default.createElement(
                'div',
                { className: 'k-DevGrid__col' },
                _react2.default.createElement('div', { className: 'k-DevGrid__inner' })
              ),
              _react2.default.createElement(
                'div',
                { className: 'k-DevGrid__col' },
                _react2.default.createElement('div', { className: 'k-DevGrid__inner' })
              ),
              _react2.default.createElement(
                'div',
                { className: 'k-DevGrid__col' },
                _react2.default.createElement('div', { className: 'k-DevGrid__inner' })
              ),
              _react2.default.createElement(
                'div',
                { className: 'k-DevGrid__col' },
                _react2.default.createElement('div', { className: 'k-DevGrid__inner' })
              ),
              _react2.default.createElement(
                'div',
                { className: 'k-DevGrid__col' },
                _react2.default.createElement('div', { className: 'k-DevGrid__inner' })
              ),
              _react2.default.createElement(
                'div',
                { className: 'k-DevGrid__col' },
                _react2.default.createElement('div', { className: 'k-DevGrid__inner' })
              ),
              _react2.default.createElement(
                'div',
                { className: 'k-DevGrid__col' },
                _react2.default.createElement('div', { className: 'k-DevGrid__inner' })
              ),
              _react2.default.createElement(
                'div',
                { className: 'k-DevGrid__col' },
                _react2.default.createElement('div', { className: 'k-DevGrid__inner' })
              )
            )
          )
        )
      );
    }
  }]);

  return DevGrid;
}(_react2.default.Component);

DevGrid.defaultProps = {
  storageKey: 'k-devgrid'
};