'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CommentAvatar = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _marger = require('kitten/components/layout/marger');

var _buttonImage = require('kitten/components/buttons/button-image');

var _text = require('kitten/components/typography/text');

var _colorsConfig = require('kitten/constants/colors-config');

var _colorsConfig2 = _interopRequireDefault(_colorsConfig);

var _mediaQueries = require('kitten/hoc/media-queries');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CommentAvatarComponent = function (_Component) {
  _inherits(CommentAvatarComponent, _Component);

  function CommentAvatarComponent() {
    _classCallCheck(this, CommentAvatarComponent);

    return _possibleConstructorReturn(this, (CommentAvatarComponent.__proto__ || Object.getPrototypeOf(CommentAvatarComponent)).apply(this, arguments));
  }

  _createClass(CommentAvatarComponent, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          avatarImgProps = _props.avatarImgProps,
          viewportIsMobile = _props.viewportIsMobile;


      return _react2.default.createElement(
        'div',
        { style: styles.avatar },
        _react2.default.createElement(
          _marger.Marger,
          { bottom: '1' },
          _react2.default.createElement(_buttonImage.ButtonImage, {
            tag: 'span',
            huge: !viewportIsMobile,
            big: viewportIsMobile,
            withoutPointerEvents: true,
            img: avatarImgProps
          })
        ),
        this.renderDate()
      );
    }
  }, {
    key: 'renderDate',
    value: function renderDate() {
      var commentDate = this.props.commentDate;


      if (!commentDate) return;

      return _react2.default.createElement(
        _text.Text,
        { size: 'micro', weight: 'light', color: 'font1' },
        commentDate
      );
    }
  }]);

  return CommentAvatarComponent;
}(_react.Component);

CommentAvatarComponent.propTypes = {
  avatarImgProps: _propTypes2.default.object.isRequired,
  commentDate: _propTypes2.default.string
};
CommentAvatarComponent.defaultProps = {
  commentDate: ''
};


var styles = {
  avatar: {
    display: 'flex',
    flexDirection: 'column',
    alignItems: 'center'
  }
};

var CommentAvatar = exports.CommentAvatar = (0, _mediaQueries.mediaQueries)((0, _radium2.default)(CommentAvatarComponent), {
  viewportIsMobile: true
});