'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LocationInput = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactPlacesAutocomplete = require('react-places-autocomplete');

var _reactPlacesAutocomplete2 = _interopRequireDefault(_reactPlacesAutocomplete);

var _locationIcon = require('kitten/components/icons/location-icon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// Via "https://github.com/kenny-hibino/react-places-autocomplete"


// Make sure you include a script to the Google Maps places API.
// For example:
//   <script src="https://maps.googleapis.com/maps/api/js?key=…&libraries=places"></script>

var LocationInput = exports.LocationInput = function (_Component) {
  _inherits(LocationInput, _Component);

  function LocationInput(props) {
    _classCallCheck(this, LocationInput);

    var _this = _possibleConstructorReturn(this, (LocationInput.__proto__ || Object.getPrototypeOf(LocationInput)).call(this, props));

    _this.state = {
      address: _this.props.defaultValue
    };

    _this.handleChange = _this.handleChange.bind(_this);
    _this.handleSelect = _this.handleSelect.bind(_this);
    return _this;
  }

  _createClass(LocationInput, [{
    key: 'handleChange',
    value: function handleChange(address) {
      this.setState({ address: address });
      this.props.onChange({ value: address, name: this.props.name });
    }
  }, {
    key: 'handleSelect',
    value: function handleSelect(address, placeId) {
      var _this2 = this;

      (0, _reactPlacesAutocomplete.geocodeByPlaceId)(placeId).then(function (results) {
        var place = results[0];

        if (place) {
          _this2.setState({ address: address });
          _this2.props.onSelect({ value: address, placeId: placeId, place: place });
        }
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          onChange = _props.onChange,
          onSelect = _props.onSelect,
          defaultValue = _props.defaultValue,
          inputProps = _props.inputProps,
          others = _objectWithoutProperties(_props, ['onChange', 'onSelect', 'defaultValue', 'inputProps']);

      var placesClassNames = {
        root: 'k-LocationInput__group',
        input: 'k-LocationInput__input',
        autocompleteContainer: 'k-LocationInput__autocomplete',
        autocompleteItem: 'k-LocationInput__autocompleteItem',
        autocompleteItemActive: 'k-LocationInput__autocompleteItem--active'
      };

      var autocompleteItem = function autocompleteItem(_ref) {
        var formattedSuggestion = _ref.formattedSuggestion;
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(_locationIcon.LocationIcon, { width: '12px', height: '15px' }),
          _react2.default.createElement(
            'span',
            { className: 'k-LocationInput__autocompleteItem__mainText' },
            formattedSuggestion.mainText
          ),
          ' ',
          _react2.default.createElement(
            'span',
            { className: 'k-LocationInput__autocompleteItem__secondaryText' },
            formattedSuggestion.secondaryText
          )
        );
      };

      var finalInputProps = _extends({}, inputProps, {
        value: this.state.address,
        onChange: this.handleChange
      });

      return _react2.default.createElement(
        'div',
        { className: 'k-LocationInput' },
        _react2.default.createElement(
          'div',
          { className: 'k-LocationInput__icon' },
          _react2.default.createElement(_locationIcon.LocationIcon, null)
        ),
        _react2.default.createElement(_reactPlacesAutocomplete2.default, _extends({
          classNames: placesClassNames,
          autocompleteItem: autocompleteItem,
          inputProps: finalInputProps,
          onSelect: this.handleSelect,
          hideLabel: true
        }, others))
      );
    }
  }]);

  return LocationInput;
}(_react.Component);

LocationInput.defaultProps = {
  onChange: function onChange() {},
  onSelect: function onSelect() {},
  defaultValue: ''
};