'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RadioButton = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RadioButton = exports.RadioButton = function (_Component) {
  _inherits(RadioButton, _Component);

  function RadioButton() {
    _classCallCheck(this, RadioButton);

    return _possibleConstructorReturn(this, (RadioButton.__proto__ || Object.getPrototypeOf(RadioButton)).apply(this, arguments));
  }

  _createClass(RadioButton, [{
    key: 'renderContent',
    value: function renderContent() {
      var _props = this.props,
          children = _props.children,
          largeContent = _props.largeContent;


      if (!children) return;

      var labelContentsClassNames = (0, _classnames2.default)('k-RadioButton__labelContents', {
        'k-RadioButton__labelContents--large': largeContent
      });
      return _react2.default.createElement(
        'div',
        { className: labelContentsClassNames },
        children
      );
    }
  }, {
    key: 'renderLabel',
    value: function renderLabel() {
      var _props2 = this.props,
          children = _props2.children,
          id = _props2.id,
          large = _props2.large,
          text = _props2.text;


      var radioButtonLabelClassNames = (0, _classnames2.default)('k-RadioButton__label', { 'k-RadioButton__label--large': large }, { 'k-RadioButton__label--withContents': !!children });

      return _react2.default.createElement(
        'label',
        { htmlFor: id, className: radioButtonLabelClassNames },
        text
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          className = _props3.className,
          id = _props3.id,
          children = _props3.children,
          inputClassName = _props3.inputClassName,
          large = _props3.large,
          largeContent = _props3.largeContent,
          text = _props3.text,
          error = _props3.error,
          inputProps = _objectWithoutProperties(_props3, ['className', 'id', 'children', 'inputClassName', 'large', 'largeContent', 'text', 'error']);

      var radioButtonInputClassNames = (0, _classnames2.default)('k-RadioButton__input', inputClassName, { 'is-error': error });

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('k-RadioButton', className) },
        _react2.default.createElement('input', _extends({
          id: id,
          type: 'radio',
          className: radioButtonInputClassNames
        }, inputProps)),
        this.renderLabel(),
        this.renderContent()
      );
    }
  }]);

  return RadioButton;
}(_react.Component);

RadioButton.defaultProps = {
  text: null,
  large: false,
  largeContent: false
};