'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RichTextInput = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactCkeditorWrapper = require('react-ckeditor-wrapper');

var _reactCkeditorWrapper2 = _interopRequireDefault(_reactCkeditorWrapper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// Via "https://github.com/luigiinred/react-ckeditor-wrapper"


// Make sure you include a script to React Ckeditor Wrapper.
// For example:
//   <script src="//cdn.ckeditor.com/4.6.2/standard/ckeditor.js"></script>
var RichTextInput = exports.RichTextInput = function (_React$Component) {
  _inherits(RichTextInput, _React$Component);

  function RichTextInput(props) {
    _classCallCheck(this, RichTextInput);

    var _this = _possibleConstructorReturn(this, (RichTextInput.__proto__ || Object.getPrototypeOf(RichTextInput)).call(this, props));

    _this.state = {
      content: props.content
    };

    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  _createClass(RichTextInput, [{
    key: 'handleChange',
    value: function handleChange(value) {
      this.setState({ content: value });
      this.props.onChange({ value: value });
    }
  }, {
    key: 'config',
    value: function config() {
      var config = _extends({}, this.props.config, {
        defaultLanguage: this.props.locale,
        toolbar: this.props.toolbar
      });

      return config;
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(_reactCkeditorWrapper2.default, {
        value: this.state.content,
        config: this.config(),
        onChange: this.handleChange
      });
    }
  }]);

  return RichTextInput;
}(_react2.default.Component);

RichTextInput.defaultProps = {
  onChange: function onChange() {},
  content: '',
  locale: 'en',
  config: {
    removePlugins: 'elementspath',
    resize_enabled: false
  },
  toolbar: [{
    name: 'basicstyles',
    items: ['Bold', 'Italic', 'Underline', 'Link', 'Image']
  }, {
    name: 'clipboard',
    items: ['Undo', 'Redo']
  }]
};