'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TextInputWithLimit = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _textInput = require('kitten/components/form/text-input');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextInputWithLimit = exports.TextInputWithLimit = function (_Component) {
  _inherits(TextInputWithLimit, _Component);

  function TextInputWithLimit(props) {
    _classCallCheck(this, TextInputWithLimit);

    var _this = _possibleConstructorReturn(this, (TextInputWithLimit.__proto__ || Object.getPrototypeOf(TextInputWithLimit)).call(this, props));

    _this.state = {
      value: _this.props.defaultValue
    };

    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  _createClass(TextInputWithLimit, [{
    key: 'handleChange',
    value: function handleChange(e) {
      this.setState({ value: e.target.value });
      this.props.onChange(e);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          limit = _props.limit,
          defaultValue = _props.defaultValue,
          onChange = _props.onChange,
          disabled = _props.disabled,
          others = _objectWithoutProperties(_props, ['limit', 'defaultValue', 'onChange', 'disabled']);

      var length = this.state.value ? this.state.value.length : 0;

      var textInputLimitClassName = (0, _classnames2.default)('k-TextInputLimit', {
        'is-disabled': disabled
      });

      var counterClassName = (0, _classnames2.default)('k-TextInputLimit__counter', {
        'is-error': length > limit
      });

      return _react2.default.createElement(
        'div',
        { className: textInputLimitClassName },
        _react2.default.createElement(_textInput.TextInput, _extends({
          className: 'k-TextInputLimit__input',
          value: this.state.value,
          onChange: this.handleChange,
          disabled: disabled
        }, others)),
        _react2.default.createElement(
          'div',
          { className: counterClassName },
          limit - length
        )
      );
    }
  }]);

  return TextInputWithLimit;
}(_react.Component);

TextInputWithLimit.defaultProps = {
  tag: 'input',
  limit: 80,
  defaultValue: '',
  disabled: false,
  onChange: function onChange() {}
};