'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TextInputWithUnit = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _textInput = require('kitten/components/form/text-input');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextInputWithUnit = exports.TextInputWithUnit = function (_Component) {
  _inherits(TextInputWithUnit, _Component);

  function TextInputWithUnit() {
    _classCallCheck(this, TextInputWithUnit);

    return _possibleConstructorReturn(this, (TextInputWithUnit.__proto__ || Object.getPrototypeOf(TextInputWithUnit)).apply(this, arguments));
  }

  _createClass(TextInputWithUnit, [{
    key: 'blur',
    value: function blur() {
      this.input.blur();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          valid = _props.valid,
          error = _props.error,
          type = _props.type,
          unit = _props.unit,
          unitWord = _props.unitWord,
          tiny = _props.tiny,
          disabled = _props.disabled,
          digits = _props.digits,
          others = _objectWithoutProperties(_props, ['className', 'valid', 'error', 'type', 'unit', 'unitWord', 'tiny', 'disabled', 'digits']);

      var textInputClassName = (0, _classnames2.default)('k-TextInputWithUnit__input', className);

      var unitClassName = (0, _classnames2.default)('k-TextInputWithUnit__unit', {
        'k-TextInputWithUnit__unit--tiny': tiny,
        'k-TextInputWithUnit__unitWord': unitWord,
        'is-valid': valid,
        'is-error': error,
        'is-inactive': disabled
      });

      var textInputWithUnitClassName = (0, _classnames2.default)('k-TextInputWithUnit', {
        'k-TextInputWithUnit--fullWidth': !digits
      });

      return _react2.default.createElement(
        'div',
        { className: textInputWithUnitClassName },
        _react2.default.createElement(_textInput.TextInput, _extends({
          type: type,
          className: textInputClassName,
          valid: valid,
          error: error,
          tiny: tiny,
          disabled: disabled,
          digits: digits,
          ref: function ref(input) {
            return _this2.input = input;
          }
        }, others, {
          tag: 'input'
        })),
        _react2.default.createElement(
          'span',
          { className: unitClassName },
          unit
        )
      );
    }
  }]);

  return TextInputWithUnit;
}(_react.Component);

TextInputWithUnit.defaultProps = {
  unit: 'λ',
  unitWord: false,
  type: 'number',
  placeholder: null,
  valid: false,
  error: false,
  tiny: false,
  disabled: false,
  digits: null
};