'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TextInput = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextInput = exports.TextInput = function (_Component) {
  _inherits(TextInput, _Component);

  function TextInput() {
    _classCallCheck(this, TextInput);

    return _possibleConstructorReturn(this, (TextInput.__proto__ || Object.getPrototypeOf(TextInput)).apply(this, arguments));
  }

  _createClass(TextInput, [{
    key: 'focus',
    value: function focus() {
      this.input.focus();
    }
  }, {
    key: 'blur',
    value: function blur() {
      this.input.blur();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          tag = _props.tag,
          valid = _props.valid,
          error = _props.error,
          disabled = _props.disabled,
          tiny = _props.tiny,
          digits = _props.digits,
          name = _props.name,
          others = _objectWithoutProperties(_props, ['className', 'tag', 'valid', 'error', 'disabled', 'tiny', 'digits', 'name']);

      var textInputClassName = (0, _classnames2.default)('k-TextInput', className, {
        'k-TextInput--tiny': tiny,
        'k-TextAreaWrapper__input': tag == 'textarea',
        'is-valid': valid,
        'is-error': error,
        'is-disabled': disabled,
        'k-TextInput--twoDigits': digits == 2,
        'k-TextInput--twelveDigits': digits == 12
      });

      if (tag == 'textarea') {
        return _react2.default.createElement(
          'div',
          { className: 'k-TextAreaWrapper' },
          _react2.default.createElement('textarea', _extends({
            className: textInputClassName,
            ref: function ref(input) {
              return _this2.input = input;
            },
            disabled: disabled,
            name: name
          }, others)),
          _react2.default.createElement('div', { className: 'k-TextAreaWrapper__gradient' })
        );
      } else {
        return _react2.default.createElement('input', _extends({
          className: textInputClassName,
          ref: function ref(input) {
            return _this2.input = input;
          },
          disabled: disabled,
          type: 'text',
          name: name
        }, others));
      }
    }
  }]);

  return TextInput;
}(_react.Component);

TextInput.defaultProps = {
  tag: 'input', // or 'textarea'
  valid: false,
  error: false,
  disabled: false,
  tiny: false,
  digits: null,
  name: 'text'
};