'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Container = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _mediaQueries = require('kitten/helpers/utils/media-queries');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Container = exports.Container = function (_React$PureComponent) {
  _inherits(Container, _React$PureComponent);

  function Container(props, context) {
    _classCallCheck(this, Container);

    var _this = _possibleConstructorReturn(this, (Container.__proto__ || Object.getPrototypeOf(Container)).call(this, props, context));

    _this.onScreenSizeChange = function (event) {
      _this.setState({ isBelowScreenSize: event.matches });
    };

    _this.mqBelowScreenSize = props.fullWidthBelowScreenSize && (0, _mediaQueries.createMatchMediaMax)(props.fullWidthBelowScreenSize);

    _this.state = {
      isBelowScreenSize: false
    };
    return _this;
  }

  _createClass(Container, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.mqBelowScreenSize) {
        this.mqBelowScreenSize.addListener(this.onScreenSizeChange);
        this.onScreenSizeChange(this.mqBelowScreenSize);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.mqBelowScreenSize && this.mqBelowScreenSize.removeListener(this.onScreenSizeChange);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          fullWidthBelowScreenSize = _props.fullWidthBelowScreenSize,
          props = _objectWithoutProperties(_props, ['className', 'fullWidthBelowScreenSize']);

      var isBelowScreenSize = this.state.isBelowScreenSize;


      var containerClassName = (0, _classnames2.default)('k-Container', className, {
        'k-Container--no-padding': isBelowScreenSize
      });

      return _react2.default.createElement('div', _extends({ className: containerClassName }, props));
    }
  }]);

  return Container;
}(_react2.default.PureComponent);

Container.defaultProps = {
  className: null,
  fullWidthBelowScreenSize: null
};