'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GridCol = exports.Grid = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _screenConfig = require('kitten/constants/screen-config');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Grid = exports.Grid = function (_Component) {
  _inherits(Grid, _Component);

  function Grid() {
    _classCallCheck(this, Grid);

    return _possibleConstructorReturn(this, (Grid.__proto__ || Object.getPrototypeOf(Grid)).apply(this, arguments));
  }

  _createClass(Grid, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          others = _objectWithoutProperties(_props, ['className']);

      var gridClassName = (0, _classnames2.default)('k-Grid', className);

      return _react2.default.createElement('div', _extends({ className: gridClassName }, others));
    }
  }]);

  return Grid;
}(_react.Component);

var GridCol = exports.GridCol = function (_React$Component) {
  _inherits(GridCol, _React$Component);

  function GridCol() {
    _classCallCheck(this, GridCol);

    return _possibleConstructorReturn(this, (GridCol.__proto__ || Object.getPrototypeOf(GridCol)).apply(this, arguments));
  }

  _createClass(GridCol, [{
    key: 'classByMediaQuery',
    value: function classByMediaQuery() {
      var props = this.props;

      var classNamesByMediaQuery = Object.keys(_screenConfig.ScreenConfig).map(function (size) {
        var _classNames;

        var mediaQuery = size.toLowerCase();
        var col = props['col-' + mediaQuery];
        var offset = props['offset-' + mediaQuery];

        return (0, _classnames2.default)(classNamesByMediaQuery, (_classNames = {}, _defineProperty(_classNames, 'k-Grid__col--' + col + '@' + mediaQuery, col), _defineProperty(_classNames, 'k-Grid__col--offset-' + offset + '@' + mediaQuery, offset), _classNames));
      });

      return classNamesByMediaQuery;
    }
  }, {
    key: 'render',
    value: function render() {
      var _classNames2;

      var _props2 = this.props,
          col = _props2.col,
          offset = _props2.offset,
          className = _props2.className,
          others = _objectWithoutProperties(_props2, ['col', 'offset', 'className']);

      var gridClassNames = (0, _classnames2.default)((_classNames2 = {}, _defineProperty(_classNames2, 'k-Grid__col--' + col, col), _defineProperty(_classNames2, 'k-Grid__col--offset-' + offset, offset), _classNames2), this.classByMediaQuery(), className);

      // Remove unknown props in others.
      Object.keys(_screenConfig.ScreenConfig).map(function (size) {
        var mediaQuery = size.toLowerCase();
        delete others['col-' + mediaQuery];
        delete others['offset-' + mediaQuery];
      });

      return _react2.default.createElement('div', _extends({}, others, { className: gridClassNames }));
    }
  }]);

  return GridCol;
}(_react2.default.Component);

Grid.defaultProps = {
  className: null
};

GridCol.defaultProps = {
  col: '12',
  offset: null,
  className: null
};