'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LegoGrid = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactMasonryComponent = require('react-masonry-component');

var _reactMasonryComponent2 = _interopRequireDefault(_reactMasonryComponent);

var _screenConfig = require('kitten/constants/screen-config');

var _gridConfig = require('kitten/constants/grid-config');

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LegoGridBase = function (_Component) {
  _inherits(LegoGridBase, _Component);

  function LegoGridBase(props) {
    _classCallCheck(this, LegoGridBase);

    var _this = _possibleConstructorReturn(this, (LegoGridBase.__proto__ || Object.getPrototypeOf(LegoGridBase)).call(this, props));

    _this.state = {
      show: false
    };
    return _this;
  }

  _createClass(LegoGridBase, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setState({ show: true });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          masonryProps = _props.masonryProps,
          children = _props.children,
          others = _objectWithoutProperties(_props, ['className', 'masonryProps', 'children']);

      var classByMediaQuery = function classByMediaQuery() {
        var classNamesByMediaQuery = Object.keys(_screenConfig.ScreenConfig).map(function (size) {
          var mediaQuery = size.toLowerCase();
          var items = _this2.props['items-' + mediaQuery + '-up'];

          return (0, _classnames2.default)(classNamesByMediaQuery, _defineProperty({}, 'k-LegoGrid--' + _gridConfig.NUM_COLUMNS / items + 'col@' + mediaQuery, items));
        });

        return classNamesByMediaQuery;
      };

      var gridClassName = (0, _classnames2.default)('k-LegoGrid', classByMediaQuery(), className);
      var masonryStyle = [styles.masonry, !this.state.show && styles.masonry.hidden, others.style];

      return _react2.default.createElement(
        'div',
        _extends({ className: gridClassName }, others, { style: masonryStyle }),
        _react2.default.createElement(
          _reactMasonryComponent2.default,
          masonryProps,
          children
        )
      );
    }
  }]);

  return LegoGridBase;
}(_react.Component);

LegoGridBase.defaultProps = {
  className: null,
  masonryProps: {}
};
var LegoGrid = exports.LegoGrid = (0, _radium2.default)(LegoGridBase);

LegoGrid.Item = function (_ref) {
  var children = _ref.children,
      props = _objectWithoutProperties(_ref, ['children']);

  var itemClassName = (0, _classnames2.default)('k-LegoGrid__item', props.className);

  return _react2.default.createElement(
    'div',
    _extends({}, props, { className: itemClassName }),
    _react2.default.createElement(
      'div',
      { className: 'k-LegoGrid__item__content' },
      children
    )
  );
};

LegoGrid.Item.defaultProps = {
  className: null
};

var styles = {
  masonry: {
    opacity: 1,
    visibility: 'visible',
    transition: 'opacity .5s, visibility .5s',

    hidden: {
      visibility: 'hidden',
      opacity: 0
    }
  }
};