'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Row = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Row = function Row(_ref) {
  var className = _ref.className,
      contentClassName = _ref.contentClassName,
      centered = _ref.centered,
      light = _ref.light,
      dark = _ref.dark,
      lightTopBorder = _ref.lightTopBorder,
      lightBottomBorder = _ref.lightBottomBorder,
      padded = _ref.padded,
      children = _ref.children,
      others = _objectWithoutProperties(_ref, ['className', 'contentClassName', 'centered', 'light', 'dark', 'lightTopBorder', 'lightBottomBorder', 'padded', 'children']);

  var rowClassName = (0, _classnames2.default)('k-Row', {
    'k-Row--centered': centered,
    'k-Row--light': light,
    'k-Row--dark': dark,
    'k-Row--lightTopBorder': lightTopBorder,
    'k-Row--lightBottomBorder': lightBottomBorder,
    'k-Row--padded': padded
  }, className);

  var rowContentClassName = (0, _classnames2.default)('k-Row__content', contentClassName);

  return _react2.default.createElement(
    'div',
    _extends({ className: rowClassName }, others),
    _react2.default.createElement(
      'div',
      { className: rowContentClassName },
      children
    )
  );
};

exports.Row = Row;
Row.defaultProps = {
  className: null,
  contentClassName: null,
  centered: false,
  light: false,
  dark: false,
  lightTopBorder: false,
  lightBottomBorder: false,
  padded: false
};