'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HeaderItem = exports.HeaderItems = exports.Header = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Header = exports.Header = function (_React$Component) {
  _inherits(Header, _React$Component);

  function Header() {
    _classCallCheck(this, Header);

    return _possibleConstructorReturn(this, (Header.__proto__ || Object.getPrototypeOf(Header)).apply(this, arguments));
  }

  _createClass(Header, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          children = _props.children,
          fixed = _props.fixed,
          other = _objectWithoutProperties(_props, ['className', 'children', 'fixed']);

      var headerClassName = (0, _classnames2.default)('k-Header', { 'is-fixed': fixed }, className);

      return _react2.default.createElement(
        'header',
        _extends({ className: headerClassName, role: 'banner' }, other),
        _react2.default.createElement(
          'div',
          { className: 'k-Header__container' },
          _react2.default.createElement(
            'div',
            { className: 'k-Header__row' },
            children
          )
        )
      );
    }
  }]);

  return Header;
}(_react2.default.Component);

var HeaderItems = exports.HeaderItems = function (_React$Component2) {
  _inherits(HeaderItems, _React$Component2);

  function HeaderItems() {
    _classCallCheck(this, HeaderItems);

    return _possibleConstructorReturn(this, (HeaderItems.__proto__ || Object.getPrototypeOf(HeaderItems)).apply(this, arguments));
  }

  _createClass(HeaderItems, [{
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          className = _props2.className,
          fixedSize = _props2.fixedSize,
          other = _objectWithoutProperties(_props2, ['className', 'fixedSize']);

      var itemsClassName = (0, _classnames2.default)('k-Header__items', { 'k-Header__items--fixedSize': fixedSize }, className);

      return _react2.default.createElement('div', _extends({ className: itemsClassName }, other));
    }
  }]);

  return HeaderItems;
}(_react2.default.Component);

var HeaderItem = exports.HeaderItem = function (_React$Component3) {
  _inherits(HeaderItem, _React$Component3);

  function HeaderItem() {
    _classCallCheck(this, HeaderItem);

    return _possibleConstructorReturn(this, (HeaderItem.__proto__ || Object.getPrototypeOf(HeaderItem)).apply(this, arguments));
  }

  _createClass(HeaderItem, [{
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          className = _props3.className,
          fixedSize = _props3.fixedSize,
          centered = _props3.centered,
          tag = _props3.tag,
          other = _objectWithoutProperties(_props3, ['className', 'fixedSize', 'centered', 'tag']);

      var Tag = tag;
      var itemClassName = (0, _classnames2.default)('k-Header__item', {
        'k-Header__item--fixedSize': fixedSize,
        'k-Header__item--centered': centered
      }, className);

      return _react2.default.createElement(Tag, _extends({ className: itemClassName }, other));
    }
  }]);

  return HeaderItem;
}(_react2.default.Component);

Header.defaultProps = {
  fixed: false
};

HeaderItems.defaultProps = {
  fixedSize: false
};

HeaderItem.defaultProps = {
  tag: 'div', // 'div', 'p', 'nav', …
  fixedSize: false,
  centered: false
};