'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InfoLines = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InfoLines = exports.InfoLines = function (_Component) {
  _inherits(InfoLines, _Component);

  function InfoLines(props) {
    _classCallCheck(this, InfoLines);

    var _this = _possibleConstructorReturn(this, (InfoLines.__proto__ || Object.getPrototypeOf(InfoLines)).call(this, props));

    _this.renderInfo = _this.renderInfo.bind(_this);
    return _this;
  }

  _createClass(InfoLines, [{
    key: 'renderInfos',
    value: function renderInfos() {
      return this.props.infos.map(this.renderInfo);
    }
  }, {
    key: 'renderInfo',
    value: function renderInfo(element) {
      var key = element.key,
          value = element.value,
          id = element.id,
          className = element.className,
          style = element.style,
          others = _objectWithoutProperties(element, ['key', 'value', 'id', 'className', 'style']);

      var infoClassName = (0, _classnames2.default)('k-InfoLines__line', className);

      var infoStyle = _extends({}, style, {
        borderColor: this.props.borderColor
      });

      return _react2.default.createElement(
        'div',
        _extends({}, others, { key: id, className: infoClassName, style: infoStyle }),
        _react2.default.createElement(
          'div',
          { className: 'k-InfoLines__line__key' },
          key
        ),
        _react2.default.createElement(
          'div',
          { className: 'k-InfoLines__line__value' },
          value
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          borderColor = _props.borderColor,
          className = _props.className,
          infos = _props.infos,
          withBorderRadius = _props.withBorderRadius,
          withLeftRightBorder = _props.withLeftRightBorder,
          withoutResponsive = _props.withoutResponsive,
          withoutTopBottomBorder = _props.withoutTopBottomBorder,
          style = _props.style,
          others = _objectWithoutProperties(_props, ['borderColor', 'className', 'infos', 'withBorderRadius', 'withLeftRightBorder', 'withoutResponsive', 'withoutTopBottomBorder', 'style']);

      var infoLinesClassName = (0, _classnames2.default)('k-InfoLines', {
        'k-InfoLines--withBorderRadius': withBorderRadius,
        'k-InfoLines--withLeftRightBorder': withLeftRightBorder,
        'k-InfoLines--withoutResponsive': withoutResponsive,
        'k-InfoLines--withoutTopBottomBorder': withoutTopBottomBorder
      }, className);

      var infoLinesStyle = _extends({}, style, {
        borderColor: borderColor
      });

      return _react2.default.createElement(
        'div',
        _extends({}, others, { className: infoLinesClassName, style: infoLinesStyle }),
        this.renderInfos()
      );
    }
  }]);

  return InfoLines;
}(_react.Component);

InfoLines.defaultProps = {
  borderColor: null,
  className: null,
  infos: [], // Eg: [{ key: …, value: …, id: … }]
  withBorderRadius: false,
  withLeftRightBorder: false,
  withoutResponsive: false,
  withoutTopBottomBorder: false
};