'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TagList = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _typologyTagIcon = require('kitten/components/icons/typology-tag-icon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TagList = exports.TagList = function (_React$Component) {
  _inherits(TagList, _React$Component);

  function TagList(props) {
    _classCallCheck(this, TagList);

    var _this = _possibleConstructorReturn(this, (TagList.__proto__ || Object.getPrototypeOf(TagList)).call(this, props));

    _this.renderItem = _this.renderItem.bind(_this);
    return _this;
  }

  _createClass(TagList, [{
    key: 'renderItem',
    value: function renderItem(element, index) {
      var TagIcon = this.props.icon;

      var key = element.key,
          item = element.item;

      var isFirstItem = index == 0;
      var isLastItem = index == this.props.items.length - 1;

      var itemClassName = (0, _classnames2.default)('k-TagList__item', { 'k-TagList__item--first': isFirstItem }, { 'k-TagList__item--last': isLastItem });

      var icon = isFirstItem && _react2.default.createElement(TagIcon, { className: 'k-TagList__icon' });

      return _react2.default.createElement(
        'li',
        { key: key, className: itemClassName },
        icon,
        item
      );
    }
  }, {
    key: 'render',
    value: function render() {
      if (!this.props.items) return null;

      var _props = this.props,
          className = _props.className,
          tiny = _props.tiny,
          icon = _props.icon,
          items = _props.items,
          others = _objectWithoutProperties(_props, ['className', 'tiny', 'icon', 'items']);

      var listClassName = (0, _classnames2.default)('k-TagList', { 'k-TagList--tiny': tiny }, className);

      return _react2.default.createElement(
        'ul',
        _extends({ className: listClassName }, others),
        items.map(this.renderItem)
      );
    }
  }]);

  return TagList;
}(_react2.default.Component);

TagList.defaultProps = {
  icon: _typologyTagIcon.TypologyTagIcon,
  className: null,
  tiny: false,
  items: null
};