'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EmbedPlayer = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _colorsConfig = require('kitten/constants/colors-config');

var _colorsConfig2 = _interopRequireDefault(_colorsConfig);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _text = require('kitten/components/typography/text');

var _responsiveIframeContainer = require('kitten/components/layout/responsive-iframe-container');

var _parser = require('kitten/helpers/utils/parser');

var _screenConfig = require('kitten/constants/screen-config');

var _gridConfig = require('kitten/constants/grid-config');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PlayerButton = function PlayerButton(props) {
  return _react2.default.createElement(
    _radium.StyleRoot,
    null,
    _react2.default.createElement(
      'div',
      { style: styles.playerButton },
      _react2.default.createElement(
        _text.Text,
        { size: 'default', weight: 'regular', 'aria-label': props.playButtonLabel },
        '\u25BA'
      )
    )
  );
};

PlayerButton.propTypes = {
  playButtonLabel: _propTypes2.default.string.isRequired
};

var EmbedPlayerBase = function (_Component) {
  _inherits(EmbedPlayerBase, _Component);

  function EmbedPlayerBase(props) {
    _classCallCheck(this, EmbedPlayerBase);

    var _this = _possibleConstructorReturn(this, (EmbedPlayerBase.__proto__ || Object.getPrototypeOf(EmbedPlayerBase)).call(this, props));

    _this.handleClick = function () {
      _this.setState({ showPlayer: true });
      _this.previewVideo.blur();
    };

    _this.handleKeyPress = function (event) {
      event.preventDefault();
      var enterKey = event.key === 'Enter';
      var spaceKey = event.key === ' ';

      if (enterKey || spaceKey) _this.handleClick();
    };

    _this.handleFocus = function (event) {
      event.preventDefault();
      _this.previewVideo.focus();
      _this.handleKeyPress(event);
    };

    _this.a11yOnClickProps = function () {
      if (!_this.props.iframeHtml) return;

      return {
        onClick: _this.handleClick,
        onKeyPress: _this.handleKeyPress,
        onFocus: _this.handleFocus,
        role: 'button',
        tabIndex: 0
      };
    };

    _this.state = { showPlayer: false };
    return _this;
  }

  _createClass(EmbedPlayerBase, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          ratio = _props.ratio,
          previewProps = _props.previewProps,
          iframeHtml = _props.iframeHtml,
          playButtonLabel = _props.playButtonLabel,
          _props$style = _props.style,
          mainStyle = _props$style === undefined ? void 0 : _props$style,
          t = _props.t;


      var validRatio = parseInt(ratio, 10);
      var thumbnail = previewProps.thumbnail,
          badgeComponent = previewProps.badgeComponent,
          style = previewProps.style;

      var isVideoPlaying = iframeHtml && this.state.showPlayer;
      var playerPreviewStyle = [styles.player.base, iframeHtml ? { cursor: 'pointer' } : null, isVideoPlaying ? styles.player.hide : styles.player.show];

      return _react2.default.createElement(
        _radium.StyleRoot,
        null,
        _react2.default.createElement(
          'div',
          _extends({
            style: _extends({}, mainStyle, styles.container),
            ref: function ref(node) {
              _this2.previewVideo = node;
            }
          }, this.a11yOnClickProps()),
          _react2.default.createElement(
            'div',
            { style: playerPreviewStyle },
            iframeHtml && _react2.default.createElement(PlayerButton, { playButtonLabel: playButtonLabel }),
            _react2.default.createElement('img', {
              style: styles.thumbnail,
              src: thumbnail.src,
              alt: thumbnail.alt
            }),
            badgeComponent
          ),
          iframeHtml && _react2.default.createElement(
            'div',
            { style: styles.embedPlayer },
            _react2.default.createElement(
              _responsiveIframeContainer.ResponsiveIframeContainer,
              { ratio: validRatio },
              (0, _parser.parseHtml)(iframeHtml)
            )
          )
        )
      );
    }
  }]);

  return EmbedPlayerBase;
}(_react.Component);

EmbedPlayerBase.propTypes = {
  previewProps: _propTypes2.default.shape({
    thumbnail: _propTypes2.default.shape({
      src: _propTypes2.default.string.isRequired,
      alt: _propTypes2.default.string.isRequired,
      style: _propTypes2.default.string
    }).isRequired
  }).isRequired,
  badgeComponent: _propTypes2.default.node,
  playButtonLabel: _propTypes2.default.string.isRequired,
  ratio: _propTypes2.default.oneOf([_propTypes2.default.number, _propTypes2.default.string]).isRequired,
  iframeHtml: _propTypes2.default.string
};

EmbedPlayerBase.defaultProps = {
  previewProps: {
    thumbnail: {
      style: {}
    }
  },
  badgeComponent: null,
  iframeHtml: null
};

var playerButtonSize = 90;
var playerButtonXSSize = 50;

var styles = {
  container: {
    position: 'relative',
    display: 'block',
    width: '100%'
  },

  thumbnail: {
    display: 'block',
    width: '100%'
  },

  embedPlayer: {
    position: 'absolute',
    top: 0,
    width: '100%',
    height: '100%'
  },

  playerButton: _defineProperty({
    width: playerButtonSize + 'px',
    height: playerButtonSize + 'px',
    background: _colorsConfig2.default.background1,
    position: 'absolute',
    top: 'calc(50% - ' + playerButtonSize / 2 + 'px)',
    left: 'calc(50% - ' + playerButtonSize / 2 + 'px)',
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center'

  }, '@media (max-width: ' + _screenConfig.ScreenConfig.XS.max + 'px)', {
    width: playerButtonXSSize + 'px',
    height: playerButtonXSSize + 'px',
    top: 'calc(50% - ' + playerButtonXSSize / 2 + 'px)',
    left: 'calc(50% - ' + playerButtonXSSize / 2 + 'px)'
  }),

  player: {
    base: {
      position: 'relative',
      transition: 'opacity ease 600ms, z-index ease 600ms',
      zIndex: 1
    },
    show: {
      opacity: 1
    },
    hide: {
      opacity: 0,
      zIndex: 0
    }
  }
};

var EmbedPlayer = exports.EmbedPlayer = (0, _radium2.default)(EmbedPlayerBase);