'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Modal = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactModal = require('react-modal');

var _reactModal2 = _interopRequireDefault(_reactModal);

var _closeButton = require('kitten/components/buttons/close-button');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// Via "https://github.com/reactjs/react-modal"


var Modal = exports.Modal = function (_Component) {
  _inherits(Modal, _Component);

  function Modal(props) {
    _classCallCheck(this, Modal);

    var _this = _possibleConstructorReturn(this, (Modal.__proto__ || Object.getPrototypeOf(Modal)).call(this, props));

    _this.open = function () {
      _this.setState({ showModal: true });
    };

    _this.close = function () {
      _this.setState({ showModal: false });
      if (_this.props.onClose) {
        _this.props.onClose();
      }
    };

    _this.state = {
      showModal: false
    };
    return _this;
  }

  _createClass(Modal, [{
    key: 'renderCloseModal',
    value: function renderCloseModal() {
      return _react2.default.createElement(_closeButton.CloseButton, {
        className: 'k-Modal__close',
        modifier: 'beryllium',
        onClick: this.close
      });
    }
  }, {
    key: 'renderTriggerAction',
    value: function renderTriggerAction() {
      if (!this.props.trigger) return;

      return _react2.default.createElement(
        'span',
        { className: 'k-Modal__trigger', onClick: this.open },
        this.props.trigger
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          trigger = _props.trigger,
          content = _props.content,
          label = _props.label,
          labelledby = _props.labelledby,
          describedby = _props.describedby,
          className = _props.className,
          onClose = _props.onClose,
          others = _objectWithoutProperties(_props, ['trigger', 'content', 'label', 'labelledby', 'describedby', 'className', 'onClose']);

      var triggerClassNames = (0, _classnames2.default)('k-Modal', className);

      return _react2.default.createElement(
        'div',
        _extends({ className: triggerClassNames }, others),
        this.renderTriggerAction(),
        _react2.default.createElement(
          _reactModal2.default,
          {
            role: 'dialog',
            className: {
              base: 'k-Modal__content',
              afterOpen: 'k-Modal--afterOpen',
              beforeClose: 'k-Modal--beforeClose'
            },
            overlayClassName: {
              base: 'k-Modal__overlay',
              afterOpen: 'k-Modal__overlay--afterOpen',
              beforeClose: 'k-Modal__overlay--beforeClose'
            },
            isOpen: this.state.showModal,
            aria: {
              labelledby: labelledby,
              describedby: describedby
            },
            ariaHideApp: false,
            onRequestClose: this.close,
            contentLabel: label
          },
          content,
          this.renderCloseModal()
        )
      );
    }
  }]);

  return Modal;
}(_react.Component);

Modal.propTypes = {
  label: _propTypes2.default.string,
  labelledby: _propTypes2.default.string,
  describedby: _propTypes2.default.string
};

Modal.defaultProps = {
  label: 'Modal',
  labelledby: '',
  describedby: ''
};