'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HorizontalNav = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _badge = require('kitten/components/notifications/badge');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactMarkdown = require('react-markdown');

var _reactMarkdown2 = _interopRequireDefault(_reactMarkdown);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HorizontalNav = exports.HorizontalNav = function (_Component) {
  _inherits(HorizontalNav, _Component);

  function HorizontalNav() {
    _classCallCheck(this, HorizontalNav);

    return _possibleConstructorReturn(this, (HorizontalNav.__proto__ || Object.getPrototypeOf(HorizontalNav)).apply(this, arguments));
  }

  _createClass(HorizontalNav, [{
    key: 'renderItems',
    value: function renderItems() {
      var _this2 = this;

      var items = this.props.items;


      return items.map(function (item) {
        return _this2.renderItem(item);
      });
    }
  }, {
    key: 'renderItem',
    value: function renderItem(item) {
      var markdown = this.props.markdown;

      var className = item.className,
          selected = item.selected,
          text = item.text,
          badge = item.badge,
          key = item.key,
          href = item.href,
          others = _objectWithoutProperties(item, ['className', 'selected', 'text', 'badge', 'key', 'href']);

      var itemClassName = (0, _classnames2.default)('k-HorizontalNav__item', className, {
        'is-selected': selected
      });

      var renderBadge = _react2.default.createElement(
        _react.Fragment,
        null,
        text,
        _react2.default.createElement(
          _badge.Badge,
          { className: 'k-HorizontalNav__badge' },
          badge
        )
      );

      var renderMarkdown = markdown ? _react2.default.createElement(_reactMarkdown2.default, { softBreak: 'br', source: text }) : text;

      var renderText = badge ? renderBadge : renderMarkdown;

      return _react2.default.createElement(
        'li',
        _extends({
          className: (0, _classnames2.default)('k-HorizontalNav__element', this.props.elementClassName),
          key: key,
          role: 'menuitem'
        }, others),
        _react2.default.createElement(
          'a',
          {
            href: href,
            className: itemClassName,
            style: {
              height: this.props.height
            }
          },
          renderText
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          center = _props.center,
          others = _objectWithoutProperties(_props, ['className', 'center']);

      var navClassNames = (0, _classnames2.default)('k-HorizontalNav', className, {
        'k-HorizontalNav--center': center
      });

      return _react2.default.createElement(
        'ul',
        { role: 'menubar', id: this.props.id, className: navClassNames },
        this.renderItems()
      );
    }
  }]);

  return HorizontalNav;
}(_react.Component);

HorizontalNav.defaultProps = {
  id: null,
  className: null,
  height: 'auto',
  center: false,
  elementClassName: null,
  items: [], // Eg: [{ key: …, text: …, href: …, selected: …, badge: … }]
  markdown: true
};