'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TabBar = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactMarkdown = require('react-markdown');

var _reactMarkdown2 = _interopRequireDefault(_reactMarkdown);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TabBar = exports.TabBar = function (_Component) {
  _inherits(TabBar, _Component);

  function TabBar() {
    _classCallCheck(this, TabBar);

    return _possibleConstructorReturn(this, (TabBar.__proto__ || Object.getPrototypeOf(TabBar)).apply(this, arguments));
  }

  _createClass(TabBar, [{
    key: 'renderItems',
    value: function renderItems() {
      var _this2 = this;

      var items = this.props.items;


      return items.map(function (item, key) {
        return _this2.renderItem(item, key);
      });
    }
  }, {
    key: 'renderItem',
    value: function renderItem(item, key) {
      var className = item.className,
          selected = item.selected,
          text = item.text,
          linkProps = _objectWithoutProperties(item, ['className', 'selected', 'text']);

      var itemClassName = (0, _classnames2.default)('k-TabBar__item', className, {
        'is-selected': selected
      });

      return _react2.default.createElement(
        'li',
        { key: key },
        _react2.default.createElement(
          'a',
          _extends({ className: itemClassName }, linkProps),
          _react2.default.createElement(_reactMarkdown2.default, { softBreak: 'br', source: text })
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        {
          id: this.props.id,
          className: (0, _classnames2.default)('k-TabBar', this.props.className)
        },
        _react2.default.createElement(
          'nav',
          { className: (0, _classnames2.default)('k-TabBar__nav', this.props.navClassName) },
          _react2.default.createElement(
            'ul',
            {
              className: (0, _classnames2.default)('k-TabBar__list', this.props.listClassName)
            },
            this.renderItems()
          )
        )
      );
    }
  }]);

  return TabBar;
}(_react.Component);

TabBar.defaultProps = {
  id: null,
  className: null,
  navClassName: null,
  listClassName: null,
  items: []
};