'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.IconBadge = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _colorsConfig = require('kitten/constants/colors-config');

var _colorsConfig2 = _interopRequireDefault(_colorsConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var IconBadge = exports.IconBadge = function (_Component) {
  _inherits(IconBadge, _Component);

  function IconBadge() {
    _classCallCheck(this, IconBadge);

    return _possibleConstructorReturn(this, (IconBadge.__proto__ || Object.getPrototypeOf(IconBadge)).apply(this, arguments));
  }

  _createClass(IconBadge, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          valid = _props.valid,
          big = _props.big,
          huge = _props.huge,
          style = _props.style,
          others = _objectWithoutProperties(_props, ['children', 'valid', 'big', 'huge', 'style']);

      var styleBadge = [styles.badge, valid && styles.badge.isValid, big && styles.badge.big, huge && styles.badge.huge, style];

      var styleContent = [styles.content, big && styles.content.big, huge && styles.content.huge];

      return _react2.default.createElement(
        _radium.StyleRoot,
        null,
        _react2.default.createElement(
          'span',
          _extends({}, others, { style: styleBadge }),
          _react2.default.createElement(
            'span',
            { style: styleContent },
            children
          )
        )
      );
    }
  }]);

  return IconBadge;
}(_react.Component);

var bigSize = {
  minWidth: 40,
  minHeight: 40,
  borderRadius: 40
};

var hugeSize = {
  minWidth: 50,
  minHeight: 50,
  borderRadius: 50
};

var styles = {
  badge: {
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center',
    padding: 0,
    minWidth: 30,
    minHeight: 30,
    borderRadius: 30,
    backgroundColor: _colorsConfig2.default.primary1,
    big: bigSize,
    huge: hugeSize,
    isValid: {
      backgroundColor: _colorsConfig2.default.valid
    }
  },

  content: {
    flexBasis: 11,
    fill: _colorsConfig2.default.background1,
    color: _colorsConfig2.default.background1,
    textAlign: 'center',
    fontWeight: 'bold',
    fontSize: 12,
    lineHeight: 0,
    big: {
      fontSize: 14
    },
    huge: {
      fontSize: 14
    }
  }
};