'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Popover = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _marger = require('kitten/components/layout/marger');

var _closeButton = require('kitten/components/buttons/close-button');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Popover = exports.Popover = function (_Component) {
  _inherits(Popover, _Component);

  function Popover(props) {
    _classCallCheck(this, Popover);

    var _this = _possibleConstructorReturn(this, (Popover.__proto__ || Object.getPrototypeOf(Popover)).call(this, props));

    _this.handleCloseClick = _this.handleCloseClick.bind(_this);
    return _this;
  }

  _createClass(Popover, [{
    key: 'handleCloseClick',
    value: function handleCloseClick() {
      if (this.props.onCloseClick) return this.props.onCloseClick();
    }
  }, {
    key: 'renderCloseButton',
    value: function renderCloseButton() {
      return _react2.default.createElement(_closeButton.CloseButton, {
        modifier: 'beryllium',
        closeButtonLabel: this.props.closeButtonLabel,
        onClick: this.handleCloseClick
      });
    }
  }, {
    key: 'renderContent',
    value: function renderContent() {
      if (typeof this.props.children != 'string') {
        return this.props.children;
      }

      return _react2.default.createElement(
        _marger.Marger,
        { top: '5', bottom: '5', className: 'k-Popover__content' },
        this.props.children
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          popoverClassName = _props.popoverClassName,
          containerClassName = _props.containerClassName,
          titleAriaLabelId = _props.titleAriaLabelId,
          onCloseClick = _props.onCloseClick,
          closeButtonLabel = _props.closeButtonLabel,
          popoverAttributes = _objectWithoutProperties(_props, ['children', 'popoverClassName', 'containerClassName', 'titleAriaLabelId', 'onCloseClick', 'closeButtonLabel']);

      var popoverClassNames = (0, _classnames2.default)('k-Popover', popoverClassName);

      var containerClassNames = (0, _classnames2.default)('k-Popover__container', containerClassName);

      return _react2.default.createElement(
        'div',
        _extends({
          ref: 'popover',
          className: popoverClassNames,
          role: 'dialog',
          'aria-hidden': 'true',
          'aria-labelledby': titleAriaLabelId
        }, popoverAttributes),
        _react2.default.createElement(
          'div',
          { className: containerClassNames },
          this.renderContent(),
          _react2.default.createElement(
            'div',
            null,
            this.renderCloseButton()
          )
        )
      );
    }
  }]);

  return Popover;
}(_react.Component);

Popover.defaultProps = {
  onCloseClick: null,
  closeButtonLabel: 'Close',
  popoverClassName: '',
  containerClassName: ''
};