'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StepperIconValidated = exports.StepperIconInProgress = exports.StepperIconDefault = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _arrowIcon = require('kitten/components/icons/arrow-icon');

var _checkedIcon = require('kitten/components/icons/checked-icon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var StepperIcon = function StepperIcon(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var iconClassNames = (0, _classnames2.default)('k-ButtonIcon', 'k-ButtonIcon--nano', 'k-ButtonIcon--hydrogen', 'k-ButtonIcon--withoutHover', 'k-ButtonIcon--rounded', 'k-Stepper__icon', className);

  return _react2.default.createElement(
    'span',
    { className: iconClassNames },
    children
  );
};

var StepperIconDefault = exports.StepperIconDefault = function StepperIconDefault() {
  return _react2.default.createElement(StepperIcon, { className: 'k-ButtonIcon--empty--nano' });
};

var StepperIconInProgress = exports.StepperIconInProgress = function StepperIconInProgress() {
  var inProgressClassNames = (0, _classnames2.default)('k-Stepper__icon--inProgress');

  return _react2.default.createElement(
    StepperIcon,
    { className: inProgressClassNames },
    _react2.default.createElement(_arrowIcon.ArrowIcon, {
      className: (0, _classnames2.default)('k-ButtonIcon__svg', 'k-Stepper__svg')
    })
  );
};

var StepperIconValidated = exports.StepperIconValidated = function StepperIconValidated() {
  var validatedClassNames = (0, _classnames2.default)('k-Stepper__icon--validated', 'k-ButtonIcon--checked--nano');

  return _react2.default.createElement(
    StepperIcon,
    { className: validatedClassNames },
    _react2.default.createElement(_checkedIcon.CheckedIcon, {
      className: (0, _classnames2.default)('k-ButtonIcon__svg', 'k-Stepper__svg')
    })
  );
};