'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HeaderTour = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _assign = require('core-js/library/fn/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _tour = require('kitten/components/tours/tour');

var _mixIllustration = require('kitten/components/illustrations/mix-illustration');

var _loudspeakerIllustration = require('kitten/components/illustrations/loudspeaker-illustration');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// We directly use svg-react loader for the moment.
// TODO: update webpack config to manage svg in jsx files.


var HeaderTour = exports.HeaderTour = function (_React$Component) {
  _inherits(HeaderTour, _React$Component);

  function HeaderTour(props) {
    _classCallCheck(this, HeaderTour);

    return _possibleConstructorReturn(this, (HeaderTour.__proto__ || Object.getPrototypeOf(HeaderTour)).call(this, props));
  }

  // Component methods.

  _createClass(HeaderTour, [{
    key: 'isCrowdStep',
    value: function isCrowdStep(step) {
      return step.name == 'crowdStep';
    }
  }, {
    key: 'platformSwitchStep',
    value: function platformSwitchStep() {
      var content = this.props.platformSwitchStep;
      var illustration = {
        illustration: _react2.default.createElement(_mixIllustration.MixIllustration, { className: 'k-Tour__popover__svg--primary' })
      };

      return (0, _assign2.default)(content, illustration);
    }
  }, {
    key: 'crowdStep',
    value: function crowdStep() {
      var content = this.props.crowdStep;
      var illustration = {
        illustration: _react2.default.createElement(_loudspeakerIllustration.LoudspeakerIllustration, { className: 'k-Tour__popover__svg--primary' })
      };

      return (0, _assign2.default)(content, illustration);
    }
  }, {
    key: 'steps',
    value: function steps() {
      return [this.platformSwitchStep(), this.crowdStep()];
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          platformSwitchStep = _props.platformSwitchStep,
          crowdStep = _props.crowdStep,
          otherProps = _objectWithoutProperties(_props, ['platformSwitchStep', 'crowdStep']);

      return _react2.default.createElement(_tour.Tour, _extends({ className: 'k-HeaderTour', steps: this.steps() }, otherProps));
    }
  }]);

  return HeaderTour;
}(_react2.default.Component);

HeaderTour.defaultProps = {
  storeName: 'kitten.HeaderTour'

  // DEPRECATED: do not use default export.
};exports.default = HeaderTour;